#include "mrk/ast.h"

mrk_err mrk_ast_node_init(mrk_ast_node **out) {
  MRK_CALLOC(out, 1, sizeof(mrk_ast_node));

  return mrk_err_ok;
}

mrk_err mrk_ast_node_child_append(mrk_ast_node *parent, mrk_ast_node *child) {
  mrk_ast_node **children =
      parent->children.len == 0
          ? malloc(sizeof(mrk_ast_node *))
          : realloc(parent->children.arr,
                    sizeof(mrk_ast_node *) * (parent->children.len + 1));

  if (children == NULL) {
    return mrk_err_failed_alloc;
  }

  children[parent->children.len] = child;
  parent->children.arr = children;
  parent->children.len++;

  return mrk_err_ok;
}
